;--------------------------------------------------
; SAMPLE of Printer code that works on an HP L7580
; DO NOT TRY TO EXECUTE because unnecessary code has been taken out
;   winspool.inc seems to work ok
.686
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\winspool.inc         
;include \masm32\include\spoolss.inc         

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\winspool.lib          
;includelib \masm32\lib\spoolss.lib          

WinMain                PROTO :DWORD,:DWORD,:DWORD,:DWORD
WriteToPrinter       PROTO :DWORD, :DWORD, :DWORD, :DWORD, LpBuffer: PTR WORD

.data               
cxclient                 dd       0
cxclient2               dd       0
cyclient                 dd       0
cyclient2               dd       0
colorbk                 dd       00ff0000h      ; blue
colortxt                 dd       00ffffffh      ; white 
colrtxt2                 dd       00000000h      ; black
colrtxt3                 dd       0000ffffh      ; yellow
dwNeeded            dd       0
dwReturned         dd       0
hNFont                 dd       0
holdleft                 dd       0
holdright               dd       0
holdbottom           dd       0        
holdtop                 dd       0        
pinf04                   dd       0 
saveebx                 dd       0
savemiddleofX      dd       0
saveecx                 dd       0

AppName             db   "AAAAABBBB",0  
EndMessage       db   "WHEN PRINTING IS DONE HIT THE ESCAPE KEY ",0 
szDisplayName     db   "AAAABBBB",0
szTimesNR	     db   "Courier New Bold",0

doci             DOCINFO <sizeof DOCINFO, AppName, NULL, NULL, 0> 

.data?
CommandLine LPSTR     ?
hdcPrn      HDC       ?    
hInstance   HINSTANCE ?
RR          RECT      {?}

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX, msg: MSG, hwnd: HWND, hBrush: DWORD, hdc: HDC, rr: RECT
      
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_BYTEALIGNWINDOW
 	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInst
	pop   wc.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
      invoke LoadCursor, NULL,IDC_ARROW
	mov   wc.hCursor, eax
	invoke CreateSolidBrush, colorbk          ; background color
      mov   hBrush, eax
	mov   wc.hbrBackground, eax 
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, OFFSET szDisplayName
	mov   wc.hIconSm, 0
	invoke RegisterClassEx, addr wc
      invoke SystemParametersInfo, SPI_GETWORKAREA, 0, addr RR, 0       
      mov eax, RR.left
      mov holdleft, eax
      mov eax, RR.right
      mov holdright, eax
      mov eax, RR.bottom
      mov holdbottom, eax
      mov eax, RR.top
      mov holdtop, eax
      push edx               
      push ebx
      xor edx, edx     
      mov eax, holdright     ; find middle of line 
      mov ebx, 2                
      div ebx
      mov savemiddleofX, eax  
      pop ebx
      pop edx
	INVOKE CreateWindowEx, NULL, ADDR szDisplayName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW, RR.left, RR.top, RR.right,\
           RR.bottom, NULL, NULL, hInst, NULL       
      mov   hwnd, eax
  
	INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd

; ===============================================================
;  Loop until PostQuitMessage is sent
; ===============================================================
      StartLoop:
          INVOKE GetMessage, ADDR msg, NULL, 0, 0
          cmp eax, 0
          je ExitLoop 
          INVOKE TranslateMessage, ADDR msg
          INVOKE DispatchMessage, ADDR msg
          jmp StartLoop
       ExitLoop: 
          mov eax, msg.wParam
          ret           
WinMain ENDP
  
WndProc PROC  hWnd:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM 
        LOCAL hdc: HDC,  hInst: HINSTANCE, ps:PAINTSTRUCT 
        LOCAL hMemory: DWORD, stm:SYSTEMTIME, hBrush: dword, rr: RECT

       mov   eax,iMsg 

       .IF eax==WM_CREATE
          push ebx
          invoke  EnumPrinters, PRINTER_ENUM_LOCAL, NULL, 4, NULL, \
                    0, ADDR dwNeeded, ADDR dwReturned	; Find how much memory we need (dwNeeded)
	    invoke  GlobalAlloc, GHND, dwNeeded
	    mov	    hMemory, eax
 
	    invoke  GlobalLock, eax	; Lock the memory block & return pointer to memory	
	    mov	    pinf04, eax		; Save it
	    mov	    ebx,eax		; Set reg to memory
          invoke  EnumPrinters, PRINTER_ENUM_LOCAL, NULL, 4, pinf04, \
                                  dwNeeded, ADDR dwNeeded, ADDR dwReturned
	      
	    invoke  CreateDC, NULL, PRINTER_INFO_4.pPrinterName[ebx], NULL, NULL
	    mov	    hdcPrn,eax
	    mov	    hdc,eax
	    
	    invoke  GlobalUnlock, hMemory	; Invalidate pointer to memory block
	    invoke  GlobalFree, hMemory		; Free the memory
         invoke Rectangle, hdc, 0, 0, holdright, holdbottom   ; rectangle boundries
          pop ebx   
 
      .ELSEIF eax==WM_PAINT
CkPaintSwh: 
         invoke BeginPaint, hWnd, ADDR ps
         mov hdc, eax 
       
    ; HERE WE PRINT TO THE PRINTER 
       invoke StartDoc, hdcPrn, ADDR doci
   AnotherPage:
       invoke StartPage, hdcPrn              ; start page 
       invoke  CreateFont, 200,74,0,0, FW_SEMIBOLD, FALSE,FALSE,FALSE, \
               DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
               PROOF_QUALITY, FF_DONTCARE, ADDR szTimesNR              
       mov	hNFont, eax
       invoke  SelectObject, hdcPrn, hNFont
       push eax
; sample begin      
       invoke TextOut, hdcPrn, 2100, 115, ADDR xxxx, 11              
       invoke WriteToPrinter, hdcPrn, 393, 660, 1045, ebx     
;sample end
       invoke  SelectObject, hdcPrn, eax
       invoke DeleteObject,hNFont                
       invoke EndPage, hdcPrn
       jmp AnotherPage
       
   PrintingDone:    
       invoke EndDoc, hdcPrn
       invoke SetTextColor, hdc, colrtxt3    ; text color yellow
       mov eax, holdleft
       add eax, 235
       mov cxclient, eax
       mov eax, holdtop
       add eax, 250
       mov cyclient, eax
       invoke TextOut, hdc, cxclient, cyclient, ADDR EndMessage, 41   ; screen
      .ENDIF                                           
         pop ebx
         invoke EndPaint, hWnd, ADDR ps
         
GetOut2:         
  	.ELSEIF eax==WM_DESTROY
         invoke PostQuitMessage,NULL
         ret 0
	.ENDIF

      invoke DefWindowProc, hWnd, iMsg, wParam, lParam
	ret  
WndProc ENDP

 WriteToPrinter PROC hdc: HDC, Horz1:DWORD, Horz2:DWORD, Vert4:DWORD,
               LpBuffer: PTR Word
       mov ecx, [LpBuffer]                
       mov ax, WORD PTR[ecx]
       .IF al == 030h
         mov al, 020h
       .ENDIF
       mov WORD PTR holdR, ax                            
       invoke TextOut, hdcPrn, Horz1, Vert4, ADDR holdR, 2   
       mov ecx, [LpBuffer]
       add ecx, 2
       mov ax, WORD PTR[ecx]
       .IF al == 030h
         mov al, 020h
       .ENDIF
       mov WORD PTR xxxxvvvvv, ax                   
       invoke TextOut, hdcPrn, Horz2, Vert4, ADDR xxxxvvvv, 2               
     ret
 WriteToPrinter ENDP     

end start
